#GenerateEfficientSufficient: determining skillLevel for skills that each subresource has
#Efficient skill level = 1, Sufficient = 2, if the subresource doesnt have a skill, skill level = 0

import random
import pprint
import subresourcetypedict as SBTD

#don't really need nSkills, can use the length of resource_skill_data
def EffSuff(nSkills, nSkillLevels, SRtypedict, pSuff, resource_skill_data):
    prob_suff = int(pSuff * 100)
    prob_exc = int(100 - prob_suff)
    leveldist = [1]*prob_exc+[2]*prob_suff
    RSD = resource_skill_data
    nSB = len(SRtypedict)
    nSB_types = len(RSD)
    RSL = {}
    SkillLevel=[]
    for i in range(len(RSD)): #adds sleepingskill to resourceskill matrix depending on nr of superresources
        RSD[i].insert(0,nSB)
    for i in range(nSkillLevels):
        SkillLevel.append(i+1)
    for sb in range(nSB):     #create a dictionary of each subresource and a nill-matrix the length of nSkills
        RSL.update({(sb + 1): [0]*nSkills})
    for sb, skill in RSL.items(): #assigns a skill
        for type in range(nSB_types):
            if SRtypedict[sb] == [type+1]:
                for skill2 in range(nSkills):
                    if RSD[type][skill2] >0:
                        val = random.choice(leveldist)
                        RSL[sb][skill2] = val
    for sb,skill in RSL.items(): ##forces sleep-skill level to be efficient
        RSL[sb][0]=1
    return RSL

RSD = eval(open("resourceskills.txt").read())
bgt = eval(open("battlegrouptypes.txt").read())
bg = eval(open("battlegroup.txt").read())
SRtypedict = SBTD.SBtypedict(bgt, bg)

pprint.pprint(EffSuff(15,2,SRtypedict,0.25,RSD))