def addTaskCapacity(Task, CapacityRequirement, nSkills):
    totalCapacityRequirement = 0
    for skill in range(1, nSkills):
        totalCapacityRequirement += CapacityRequirement[Task - 1][skill]
    return totalCapacityRequirement


def ValueAtLocation(SolvableTaskList, Value, Location):
    ValueForTask = []
    TotalValue = 0
    for task in SolvableTaskList[Location]:
        ValueForTask.append(Value[task-1][0])
        TotalValue = TotalValue + Value[task - 1][0]
    return TotalValue


def nTasksAtLocation(SolvableTaskList, Location):
    nTasksAtNode = 0
    for task in SolvableTaskList[Location]:
        nTasksAtNode += 1
    return nTasksAtNode


def CapacityAtLocation(SolvableTaskList, CapacityRequirement, nSkills, Location):
    TotalCapacity = 0
    for task in SolvableTaskList[Location]:
        capacity = addTaskCapacity(task, CapacityRequirement, nSkills)
        TotalCapacity = TotalCapacity + capacity
    return TotalCapacity


def CapacityPerValue(SolvableTaskList, CapacityRequirement, nSkills, Location, Value):
    TotalCapacity = CapacityAtLocation(SolvableTaskList, CapacityRequirement, nSkills, Location)
    TotalValue = ValueAtLocation(SolvableTaskList, Value, Location)
    if TotalCapacity > 0:
        capacityValue = TotalValue / TotalCapacity
    else:
        capacityValue = 0
    return capacityValue
